'use strict';

var _fsExtra = require('fs-extra');

var _fsExtra2 = _interopRequireDefault(_fsExtra);

var _save = require('./cms/operations/save');

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _ = require('./');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Builder = function Builder(root, folder, dest, flow) {
  _classCallCheck(this, Builder);

  var dataExtension = '.json';
  var templateExtension = '.' + _.config.files.templates.extension;
  var pathToJson = _path2.default.join(root, _.config.data.url);

  var files = _.fileAttr.filterLatestVersion(_.coreUtils.file.getFilesSync(this.pathToJson, true, dataExtension), flow);

  if (flow === 'publish') {
    files = _.coreUtils.file.getFilesSync(_path2.default.join(root, _.config.publish.url), true, templateExtension);
  }

  var build = function build(index) {
    var file = files[index];
    if (file.indexOf(templateExtension) > -1) {
      file = file.replace(_.config.publish.url, _.config.data.url).replace(templateExtension, dataExtension);
    }
    if (file.indexOf(dataExtension) > -1) {
      (function () {
        var json = _fsExtra2.default.readJsonSync(file);
        var text = _.cmsTemplates.template.getTemplate(json.abe_meta.template);

        _.cmsData.source.getDataList(_path2.default.dirname(json.abe_meta.link), text, json).then(function () {
          var page = new _.Page(json.abe_meta.template, text, json, true);
          (0, _save.saveHtml)(_path2.default.join(root, dest + json.abe_meta.link), page.html);
          if (files[index + 1]) build(index + 1);
        }).catch(function (e) {
          console.error(e);
          if (files[index + 1]) build(index + 1);
        });
      })();
    } else if (files[index + 1]) build(index + 1);
  };

  build(0);
};

if (process.env.ROOT && process.env.FOLDER && process.env.DEST) {
  _.config.set({ root: process.env.ROOT });
  var dest = process.env.DEST || 'tmp';
  var flow = process.env.FLOW || 'draft';
  new Builder(process.env.ROOT, process.env.FOLDER, dest, flow);
}